addHook("BotTiccmd", function(b, c)
	if srb2p then return end

	local p = players[0]
	if b and b.mo and b.valid and b.mo.valid
		if b.mo.skin == "euphorica"
			b.abltime = $ or 30
			p.boosted = $ or false
				
			if not P_IsObjectOnGround(b.mo)
				b.abltime = $1 - 1
			else
				b.abltime = 30
				p.boosted = false
			end
				
			if b.abltime <= 0
				if not (b.mo.eflags & MF_UNDERWATER)
					if P_PlayerInPain(p)
					or p.mo.z < b.mo.z + 30*FRACUNIT
					or p.mo.state == S_PLAY_BOUNCE
						b.mo.state = S_PLAY_BOUNCE
						b.bouncing = true
						P_SetObjectMomZ(b.mo, -20*b.mo.scale*P_MobjFlip(b.mo))
						b.mo.target = P_LookForEnemies(b)
					elseif p.mo.state == S_PLAY_ROLL
					or (R_PointToDist2(b.mo.x, b.mo.y, p.mo.x, p.mo.y)) >= 150*FRACUNIT
						b.mo.state = S_PLAY_TELEPORT1
					end
					if b.bouncing == true and P_IsObjectOnGround(b.mo) and (p.mo.z >= b.mo.z + 100*FRACUNIT)
						b.mo.momz = 15*b.mo.scale*P_MobjFlip(b.mo)
						S_StartSound(b.mo, sfx_s3k52)
						b.bouncelimit = $1 - 1
					end
				else
					b.mo.state = S_PLAY_SWIM
					b.mo.angle = R_PointToAngle2(b.mo.x, b.mo.y, p.mo.x, p.mo.y)
					P_SetObjectMomZ(b.mo, 5*FRACUNIT*P_MobjFlip(b.mo))
					P_Thrust(b.mo, b.mo.angle, -10*FRACUNIT)
				end
				b.abltime = 30
				return true
			end
		end
		
		if b.mo.skin == "starshy"
			if p.mo.valid
				if (p.mo.z >= b.mo.z + 200*FRACUNIT) and P_IsObjectOnGround(b.mo)
					b.stardoing = true
					S_StartSound(b.mo, sfx_strjum)
					b.mo.momz = 20*b.mo.scale*P_MobjFlip(b.mo)
					b.mo.state = S_PLAY_SPRING
					b.pflags = $1|PF_JUMPED
				end
				
				if p.mo.state == S_PLAY_TELEPORT3
					b.stardoing = true
					S_StartSound(b.mo, sfx_strjum)
					b.mo.momz = 5*b.mo.scale*P_MobjFlip(b.mo)
					P_Thrust(b.mo, b.mo.angle, 10*b.mo.scale)
					b.mo.state = S_PLAY_SPRING
					b.pflags = $1|PF_JUMPED
				end
			end
		end
	end
end)

addHook("ShouldDamage", function(euph, explosion)
	if euph and explosion
		if not (explosion.flags & MF_ENEMY or explosion.flags & MF_BOSS or explosion.flags & MF_FIRE or explosion.flags & MF_PAIN or (explosion.flags & MF_MISSILE and explosion.type ~= MT_EXPLODE) or explosion.type == MT_SPIKE or explosion.type == MT_WALLSPIKE)
			if (euph.valid) and (euph.player)
			and (explosion.valid)
				return false
			end
			if (euph.valid) and (euph.player)
			and (explosion.valid) and (explosion.flags & MF_MONITOR) and (explosion.target == euph)
				return false
			end
			if (explosion.valid) and (explosion.nodamage)
			and (euph.valid) and (euph.bot)
				return false
			end
			if (euph.valid) and (euph.player) and (explosion.valid) and (explosion.nodamage) and (explosion.target.player.bot)
				 return false
			end
		end
	end
end)

addHook("MobjCollide", function(mo, bot)
	if (mo.valid) and (mo.player) and (mo.skin == "euphorica")
	and (bot.valid) and (bot.player) and (bot.player.bot) and (bot.skin == "starshy")
	and (mo.momx == 0) and (mo.momy == 0)
	and (bot.momx == 0) and (bot.momy == 0)
		local arrow = P_SpawnMobj(mo.x, mo.y, mo.z+mo.height, MT_OVERLAY)
		arrow.state = S_FLIGHTINDICATOR
		arrow.arrow = true
		arrow.target = bot
		if (mo.player.cmd.buttons & BT_JUMP) and mo.state ~= S_PLAY_FALL
			S_StopSound(mo)
			S_StopSound(bot)
			S_StartSound(bot, sfx_cdfm23)
			P_SetObjectMomZ(mo, 20*FRACUNIT, false)
			P_SetObjectMomZ(bot, 20*FRACUNIT, false)
			mo.state = S_PLAY_FALL
			bot.player.stardoing = true
			mo.player.pflags = $1|PF_JUMPED
		end
	end
end, MT_PLAYER)