--Definitions
--I'm too lazy to actually find out how vanilla functions work lol
function A_SpawnTeleport(actor, var1, var2)
	P_SPMAngle(actor, MT_EUPHTELEPORT2, ANGLE_180, 0, 0)
	Euphorica.spawnsparks(actor, 10)
end

function A_Bounce(actor, var1, var2)
	P_SetObjectMomZ(actor, 8*FRACUNIT*P_MobjFlip(actor))
end

function A_SpawnSparkle(actor, var1, var2)
	Euphorica.spawnsparks(p.mo, 5)
	P_SetObjectMomZ(actor, 0*FRACUNIT)
	P_InstaThrust(actor, actor.angle, 0*FRACUNIT)
end

--For later on in the script, these functions need to exist.
local function PlayerMomZ(mo, speed, relative)
	if (mo.eflags & MFE_UNDERWATER) then speed = $1/2 end
	P_SetObjectMomZ(mo, speed, relative)
end	

--Defenitions for Euphorica's Various Custom States.

--Idle sleep object
freeslot("MT_ZZZZZZZZZZ", "S_ZZZZZZZZZZ", "spr_zzzz")

mobjinfo[MT_ZZZZZZZZZZ] = {
	doomednum = -1,
	spawnhealth = 1,
	spawnstate = S_ZZZZZZZZZZ,
	deathstate = S_NULL,
	xdeathstate = S_NULL,
	radius = 4*FRACUNIT,
	height = 4*FRACUNIT,
	flags = MF_NOGRAVITY|MF_NOBLOCKMAP
}

states[S_ZZZZZZZZZZ] = {SPR_ZZZZ, FF_FULLBRIGHT|A, 0, nil, 2, 2, S_ZZZZZZZZZZ}

addHook("MobjThinker", function(mo)
	mo.momz = 3*mo.scale*P_MobjFlip(mo)
end, MT_ZZZZZZZZZZ)

--Teleportation States
local t = "S_PLAY_TELEPORT"
local sp = "S_PLAY_SPARKLE"
local s = "spr2_"
freeslot(t+"1", t+"2", t+"3", t+"4", t+"5", t+"6", t+"FIX", t+"WALLJUMP", "S_PLAY_BOUNCE", "S_PLAY_BOUNCE2", "S_PLAY_ENDBOUNCE", "S_PLAY_BOUNCEEND", "S_PLAY_CANJUMP", "S_EUPH_BATTLEMOD")
freeslot(s+"tele", s+"twlj", s+"bnc1", s+"bnc2")
freeslot(sp+"1", sp+"2", sp+"3", sp+"4", sp+"5", "S_PLAY_BATTLEFALL")

states[S_PLAY_TELEPORT1] = {SPR_NULL, A, 1, nil, 2, 2, S_PLAY_TELEPORT2}
states[S_PLAY_TELEPORT2] = {SPR_NULL, A, 1, nil, 1, 2, S_PLAY_TELEPORT3}
states[S_PLAY_TELEPORT3] = {SPR_NULL, A, 1, nil, 1, 2, S_PLAY_TELEPORT4}
states[S_PLAY_TELEPORT4] = {SPR_NULL, A, 1, nil, 1, 2, S_PLAY_TELEPORT5}
states[S_PLAY_TELEPORT5] = {SPR_PLAY, SPR2_FALL, 1, nil, 2, 2, S_PLAY_TELEPORT6}
states[S_PLAY_TELEPORT6] = {SPR_PLAY, SPR2_FALL, 9999, nil, 2, 2, S_PLAY_FALL}
states[S_PLAY_TELEPORTFIX] = {SPR_PLAY, SPR2_FALL, 1, nil, 2, 2, S_PLAY_RUN}
states[S_PLAY_BOUNCE] = {SPR_PLAY, SPR2_BNC1, 350, nil, 2, 2, S_PLAY_FALL}
states[S_PLAY_BOUNCE2] = {SPR_PLAY, SPR2_BNC2, 1, nil, 2, 2, S_PLAY_BOUNCE2}
states[S_PLAY_ENDBOUNCE] = {SPR_PLAY, SPR2_SPNG, 5, A_Bounce, 2, 2, S_PLAY_FALL}
states[S_PLAY_BOUNCEEND] = {SPR_PLAY, SPR2_FALL, 9999, nil, 2, 2, S_PLAY_FALL}
states[S_EUPH_BATTLEMOD] = {SPR_PLAY, SPR2_FALL, 5, A_SpawnSparkle, 0, 0, S_PLAY_SPARKLE1}
states[S_PLAY_SPARKLE1] = {SPR_PLAY, SPR2_FALL, 5, A_SpawnSparkle, 0, 0, S_PLAY_SPARKLE2}
states[S_PLAY_SPARKLE2] = {SPR_PLAY, SPR2_FALL, 5, A_SpawnSparkle, 0, 0, S_PLAY_SPARKLE3}
states[S_PLAY_SPARKLE3] = {SPR_PLAY, SPR2_FALL, 5, A_SpawnSparkle, 0, 0, S_PLAY_SPARKLE4}
states[S_PLAY_SPARKLE4] = {SPR_PLAY, SPR2_FALL, 5, A_SpawnSparkle, 0, 0, S_PLAY_SPARKLE5}
states[S_PLAY_SPARKLE5] = {SPR_PLAY, SPR2_FALL, 5, A_SpawnSparkle, 0, 0, S_PLAY_BATTLEFALL}
states[S_PLAY_BATTLEFALL] = {SPR_PLAY, SPR2_FALL, 1, nil, 0, 0, S_PLAY_FALL}

--Doublejump State
freeslot("S_PLAY_EUPH_DOUBLEJUMP", "spr2_doub")

states[S_PLAY_EUPH_DOUBLEJUMP] = {SPR_PLAY, SPR2_DOUB, 9999, nil, 2, 2, S_PLAY_FALL}

--Teleportation Mobj States
freeslot("MT_EUPHTELEPORT", "MT_EUPHTELEPORT2", "MT_EUPHTELEPORT3", "MT_EUPHTELEPORT4", "S_T1", "S_T2", "spr_tlsp", "spr_tls2")

mobjinfo[MT_EUPHTELEPORT] = {
	doomednum = -1,
	spawnhealth = 1,
	spawnstate = S_T1,
	radius = 4*FRACUNIT,
	height = 4*FRACUNIT,
	flags = MF_NOGRAVITY|MF_NOBLOCKMAP
}

mobjinfo[MT_EUPHTELEPORT2] = {
	doomednum = -1,
	spawnhealth = 1,
	spawnstate = S_T2,
	deathstate = S_T2,
	radius = 70*FRACUNIT,
	height = 70*FRACUNIT,
	flags = MF_NOGRAVITY|MF_NOBLOCKMAP|MF_MISSILE
}

mobjinfo[MT_EUPHTELEPORT3] = {
	doomednum = -1,
	spawnhealth = 1,
	spawnstate = S_T2,
	deathstate = S_T2,
	radius = 70*FRACUNIT,
	height = 70*FRACUNIT,
	flags = MF_NOGRAVITY|MF_NOBLOCKMAP|MF_MISSILE
}

mobjinfo[MT_EUPHTELEPORT4] = {
	doomednum = -1,
	spawnhealth = 1,
	spawnstate = S_T2,
	deathstate = S_T2,
	radius = 70*FRACUNIT,
	height = 70*FRACUNIT,
	flags = MF_NOGRAVITY|MF_NOBLOCKMAP
}

states[S_T1] = {SPR_TLSP, FF_ANIMATE|A, 6, nil, 6, 1, S_NULL}
states[S_T2] = {SPR_TLS2, FF_ANIMATE|FF_TRANS30|A, 8, nil, 4, 2, S_NULL}

rawset(_G,"Euphorica",{
	spawnsparks = function(mo, num)
		if num
			local numb = tonumber(num)
			for i = 1, numb
				local sparkle = P_SPMAngle(mo, MT_SUPERSPARK, mo.angle, 0, 0)
				sparkle.momx = P_RandomRange(-FRACUNIT/2+1, FRACUNIT/2) * 64
				sparkle.momy = P_RandomRange(-FRACUNIT/2+1, FRACUNIT/2) * 64
				sparkle.momz = P_RandomFixed() * 32
				sparkle.fuse = TICRATE/2
			end
		else
			for i = 1, 20
				local sparkle = P_SPMAngle(mo, MT_SUPERSPARK, mo.angle, 0, 0)
				sparkle.momx = P_RandomRange(-FRACUNIT/2+1, FRACUNIT/2) * 64
				sparkle.momy = P_RandomRange(-FRACUNIT/2+1, FRACUNIT/2) * 64
				sparkle.momz = P_RandomFixed() * 32
				sparkle.fuse = TICRATE/2
			end
		end
	end,
	
	dispersemo = function(mo, mo2, colour)
		for i = 1, 16
			local obj = P_SpawnMobj(mo.x, mo.y, mo.z, mo2)
			obj.angle = P_RandomRange(0, 360)*ANG1
			obj.momx = P_RandomRange(-50, 50)*FRACUNIT
			obj.momy = P_RandomRange(-50, 50)*FRACUNIT
			if colour
				obj.colorized = true
				obj.color = colour
			end
			obj.fuse = TICRATE
		end
	end,
	
	donesphere = false,
})

addHook("ShouldDamage", function(t, i, s ,d)
	if t and t.valid and t.player
		if i and i.valid and i.type == MT_EUPHTELEPORT2
		or i and i.valid and i.type == MT_EUPHTELEPORT3
			if t.player == s.player
			or (gametype == GT_COOP or gametype == GT_RACE)
			or P_PlayerInPain(t.player)
			or t.player.powers[pw_invulnerability]
			or (t.state >= S_PLAY_TELEPORT1 and t.state <= S_PLAY_TELEPORT6)
				return false
			else
				if SRB2Smash
					if isSmash()
						S_StartSound(t, sfx_s3k5f)
						dealDamage(t.player, i, 30, true)
						return false
					end
				end
				return true
			end
		elseif (i and i.valid and i.player or s and s.valid and s.player)
			if t.state >= S_PLAY_TELEPORT1 and t.state <= S_PLAY_TELEPORT6
				if (t.state >= S_PLAY_TELEPORT1 and t.state <= S_PLAY_TELEPORT5)
				and not (i.state >= S_PLAY_TELEPORT1 and i.state <= S_PLAY_TELEPORT5)
					P_DamageMobj(i, t, t, 0)
				elseif (t.state >= S_PLAY_TELEPORT1 and t.state <= S_PLAY_TELEPORT5)
				and (i.state >= S_PLAY_TELEPORT1 and i.state <= S_PLAY_TELEPORT5)
					t.state = S_PLAY_FALL
					i.state = S_PLAY_FALL
					P_InstaThrust(t, t.angle, 50*FRACUNIT)
					P_InstaThrust(i, i.angle, 50*FRACUNIT)
				end
				return false
			else
				if SRB2Smash
					if isSmash()
						S_StartSound(t, sfx_s3k5f)
						dealDamage(t.player, i, 30, true)
						return false
					end
				end
				return true
			end
		end
	end
	
	if t and i and t.valid and i.valid
		if (t.state == S_PLAY_BOUNCE and i.state ~= S_PLAY_BOUNCE and i.state ~= S_PLAY_BOUNCE2)
		or (t.state == S_PLAY_BOUNCE2 and i.state ~= S_PLAY_BOUNCE2)
			P_DamageMobj(i)
			P_SetObjectMomZ(t, 5*i.mo.scale*P_MobjFlip(i))
			return false
		end
	end
end)

--Now for the stuffff

addHook("SpinSpecial", function(p)
    if p.mo.skin ~= "euphorica" then return false end
    if P_PlayerInPain(p) then return false end
	if srb2p then return end
	
	if not P_IsObjectOnGround(p.mo)
		if p.mo.state == S_PLAY_JUMP
		or p.mo.state == S_PLAY_TELEPORT6
			p.mo.state = S_PLAY_BOUNCE
			p.mo.momz = -20*p.mo.scale*P_MobjFlip(p.mo)
			p.charflags = $1|SF_NOSKID
			p.mo.flags = $1|MF_BOUNCE
			p.bouncing = true
		end
	end
end)

freeslot("sfx_etelep", "sfx_tlestp")

--Euphorica's Jump abilities
addHook("AbilitySpecial", function(p)
    if p.mo.skin ~= "euphorica" then return false end
    if P_PlayerInPain(p) then return false end
	
	if not srb2p
		if p.mo.state == S_PLAY_JUMP
		or p.mo.state == S_PLAY_BOUNCEEND
			if (p.mo.eflags & MFE_UNDERWATER)
				P_SetObjectMomZ(p.mo, 5*FRACUNIT*P_MobjFlip(p.mo))
				p.mo.state = S_PLAY_SWIM
			else
				S_StartSound(p.mo, sfx_etelep)
				p.mo.state = S_PLAY_TELEPORT1
			end
		elseif p.mo.state == S_PLAY_SWIM
			P_SetObjectMomZ(p.mo, 5*FRACUNIT*P_MobjFlip(p.mo))
			if p.cmd.forwardmove <= 1
				P_Thrust(p.mo, p.mo.angle, -10*FRACUNIT)
			elseif p.cmd.sidemove >= 1
				P_Thrust(p.mo, p.mo.angle, 10*FRACUNIT)
				P_Thrust(p.mo, p.mo.angle - ANGLE_90, 10*FRACUNIT)
				p.mo.rollangle = ANGLE_270
			elseif p.cmd.sidemove <= -1
				P_Thrust(p.mo, p.mo.angle, 10*FRACUNIT)
				P_Thrust(p.mo, p.mo.angle + ANGLE_90, 10*FRACUNIT)
				p.mo.rollangle = ANGLE_90
			end
			p.mo.state = S_PLAY_SWIM
		elseif p.mo.state == S_PLAY_TELEPORT6
			P_InstaThrust(p.mo, p.drawangle, 30*p.mo.scale)
			P_SetObjectMomZ(p.mo, 5*FRACUNIT*P_MobjFlip(p.mo))
			S_StartSound(p.mo, sfx_ngjump)
			p.mo.state = S_PLAY_SPRING
		end
	else
		if p.bouncing == false
			p.mo.state = S_PLAY_BOUNCE
			P_SetObjectMomZ(p.mo, 10*FRACUNIT)
			p.bouncing = true
			p.bouncelimit = 1
		elseif p.zoomed == false
			P_Thrust(p.mo, p.mo.angle, 10*FRACUNIT)
			S_StartSound(p.mo, sfx_zoom)
			p.zoomed = true
		end
	end
end)

addHook("PlayerThink", function(p)
	if p.mo.skin == "euphorica" and not (maptol & TOL_NIGHTS)

		// We'll need some variables...
		p.bouncing = $ or false
		p.bouncelimit = $ or 4
		p.zoomed = $ or false
		p.absorb = $ or 0 -- unused lol
		
		// If they are in the waiting state, do the z spawn:tm:
		if p.mo.state == S_PLAY_WAIT
			if (leveltime%10==0)
				local z = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z+3*FRACUNIT, MT_ZZZZZZZZZZ)
				z.color = SKINCOLOR_PURPLE
				z.fuse = TICRATE
				z.scale = p.mo.scale
				z.destscale = FRACUNIT/3
				z.angle = P_RandomRange(0, 360)*ANG1
				z.momx = P_RandomRange(-1, 1)*FRACUNIT
				z.momy = P_RandomRange(-1, 1)*FRACUNIT
			end
		end
			
		// Bouncing properties
		if p.bouncing == true
			// If they are on the ground.
			if P_IsObjectOnGround(p.mo)
				p.mo.state = S_PLAY_BOUNCE2
				Euphorica.dispersemo(p.mo, MT_SPINDUST)
				if (p.cmd.buttons & BT_USE)
					p.mo.momz = 13*p.mo.scale*P_MobjFlip(p.mo)
					S_StartSound(p.mo, sfx_s3k77)
					p.charflags = $1|SF_NOSKID
					p.mo.flags = $1|MF_BOUNCE
					p.bouncing = true
					p.pflags = $1 & ~PF_SPINNING
					p.bouncelimit = $1 - 2
					Euphorica.dispersemo(p.mo, MT_SPINDUST)
					if p.bouncelimit <= 0
						p.mo.momz = 16*p.mo.scale*P_MobjFlip(p.mo)
						S_StartSound(p.mo, sfx_s3k44)
						p.mo.state = S_PLAY_SPRING
						p.charflags = $1 & ~SF_NOSKID
						p.mo.flags = $1 & ~MF_BOUNCE
						p.bouncing = false
						p.bouncelimit = 4
						p.zoomed = false
						p.pflags = $1 & ~PF_SPINNING
					end
				else
					p.bouncelimit = $1 - 1
					p.mo.momz = 5*p.mo.scale*P_MobjFlip(p.mo)
					S_StartSound(p.mo, sfx_s3k44)
					Euphorica.dispersemo(p.mo, MT_SPINDUST)
					if p.bouncelimit <= 0
						if srb2p and (p.cmd.buttons & BT_JUMP)
							p.mo.momz = 10*p.mo.scale*P_MobjFlip(p.mo)
							S_StartSound(p.mo, sfx_zoom)
						else
							p.mo.momz = 5*p.mo.scale*P_MobjFlip(p.mo)
						end
						p.mo.state = S_PLAY_SPRING
						p.charflags = $1 & ~SF_NOSKID
						p.mo.flags = $1 & ~MF_BOUNCE
						p.bouncing = false
						p.zoomed = false
						p.bouncelimit = 4
						p.pflags = $1 & ~PF_SPINNING
					end
				end
			// Otherwise...
			else
				p.mo.state = S_PLAY_BOUNCE
				p.charflags = $1|SF_NOSKID
				p.mo.flags = $1|MF_BOUNCE
				P_SpawnGhostMobj(p.mo)
				if (p.cmd.buttons & BT_JUMP)
				and not srb2p
					p.bouncing = false
					p.bouncelimit = 4
					p.mo.momz = 3*p.mo.scale*P_MobjFlip(p.mo)
					p.pflags = $1|PF_JUMPED
					S_StartSound(p.mo, sfx_s3k52)
					p.mo.state = S_PLAY_BOUNCEEND
					p.charflags = $1 & ~SF_NOSKID
					p.mo.flags = $1 & ~MF_BOUNCE
					p.pflags = $1 & ~PF_SPINNING
				end
			end
		end
	
		if srb2p then return end

		// Teleportation.
		if p.mo.state == S_PLAY_TELEPORT2
			P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_EUPHTELEPORT)
			Euphorica.spawnsparks(p.mo, 15)
			p.mo.flags = $1|MF_NOCLIPTHING
			p.powers[pw_flashing] = $1 + 7
		elseif p.mo.state == S_PLAY_TELEPORT3 and not P_IsObjectOnGround(p.mo)
			if p.cmd.forwardmove >= 1
				if p.powers[pw_super]
					P_Thrust(p.mo, p.mo.angle, 600*p.mo.scale)
				else
					P_Thrust(p.mo, p.mo.angle, 300*p.mo.scale)
				end
			elseif p.cmd.forwardmove <= -1
				if p.powers[pw_super]
					P_Thrust(p.mo, p.mo.angle, -600*p.mo.scale)
				else
					P_InstaThrust(p.mo, p.mo.angle, -300*p.mo.scale)
				end
			elseif p.cmd.sidemove >= 1
				if p.powers[pw_super]
					P_Thrust(p.mo, p.mo.angle - ANGLE_90, 600*p.mo.scale)
				else
					P_Thrust(p.mo, p.mo.angle - ANGLE_90, 300*p.mo.scale)
				end
			elseif p.cmd.sidemove <= -1
				if p.powers[pw_super]
					P_Thrust(p.mo, p.mo.angle + ANGLE_90, 600*p.mo.scale)
				else
					P_Thrust(p.mo, p.mo.angle + ANGLE_90, 300*p.mo.scale)
				end
			else
				P_InstaThrust(p.mo, p.mo.angle, 200*FRACUNIT)
			end
		elseif p.mo.state == S_PLAY_TELEPORT4 and not P_IsObjectOnGround(p.mo)
			P_SpawnPlayerMissile(p.mo, MT_EUPHTELEPORT2, 0)
			Euphorica.spawnsparks(p.mo, 20)
			A_ForceStop(p.mo, 0, 0)
		elseif p.mo.state == S_PLAY_TELEPORT5 and not P_IsObjectOnGround(p.mo)
			P_InstaThrust(p.mo, p.mo.angle, 40*FRACUNIT)
			p.mo.flags = $1 & ~MF_NOCLIPTHING
		elseif P_IsObjectOnGround(p.mo) and p.mo.state >= S_PLAY_TELEPORT1 and p.mo.state <= S_PLAY_TELEPORT6
			p.mo.state = S_PLAY_TELEPORTFIX
			P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_EUPHTELEPORT2)
			S_StartSound(p.mo, sfx_tlestp)
			P_InstaThrust(p.mo, p.mo.angle, 50*FRACUNIT)
			p.mo.flags = $1 & ~MF_NOCLIPTHING
		else
			p.mo.flags = $1 & ~MF_NOCLIPTHING
		end

		// Speed Teleport
		if p.mo.state == S_PLAY_ROLL and p.speed >= 170*FRACUNIT
			P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_SMOKE)
			if not S_SoundPlaying(p.mo, sfx_s3k47)
				S_StartSound(p.mo, sfx_s3k47)
			end
		end
		
		// Roll Angle centering.
		if p.mo.state ~= S_PLAY_PAIN
			if p.mo.rollangle >= ANG1
				p.mo.rollangle = $1 - 5*ANG1
			elseif p.mo.rollangle <= -1*ANG1
				p.mo.rollangle = $1 + 5*ANG1
			end
		end
	end
end)
	