freeslot("MT_PSYXPLDGATHER","MT_PSYSTRCTMO","S_PSYTHOK")
mobjinfo[MT_PSYXPLDGATHER] = {spawnstate = S_PSYTHOK,
    radius = 1*FRACUNIT,
    height = 1*FRACUNIT,
	flags = MF_NOGRAVITY|MF_FLOAT}
states[S_PSYTHOK] = {SPR_THOK, FF_FULLBRIGHT|A, -1, nil, 0, 0, S_NULL}

addHook("MobjThinker", function(mo)
	if not mo then return end
	if not srb2p then return end
	
	if mo.tracer
		local dist = R_PointToDist2(mo.x, mo.y, mo.tracer.x, mo.tracer.y)
		
		if dist >= 5*FRACUNIT
			local xdiff = mo.tracer.x-mo.x
			local ydiff = mo.tracer.y-mo.y
			local zdiff = mo.tracer.z-mo.z
			mo.momx = xdiff/5
			mo.momy = ydiff/5
			mo.momz = zdiff/5
			local ghoss = P_SpawnGhostMobj(mo)
			ghoss.destscale = FRACUNIT/16
		else
			P_KillMobj(mo)
		end
	end
end, MT_PSYXPLDGATHER)